/*
Feladat: Rendezzünk egy szám kulcsú és szöveg tartalmú rekordokból álló N elemű sorozatot!
Közben számláljuk a kulcsmező-indexelések és a mozgatások számát!
*/

#include <iostream>

using namespace std;

const int MAXN = 100;
int kDb, mDb; //kulcsmező-indexelések, mozgatások száma

struct Elem {
	int kulcs;
	string tart;
};

void beolvasas(int& n, int& m, Elem x[]) {
	cerr << "Elemek szama (0.." << MAXN << "):";
	cin >> n;
	for (int i = 0; i < n; i++) {
		cerr << i + 1 << ". kulcs (1.." << n << ") es a szoveg tartalom:"; 
		cin >> x[i].kulcs >> x[i].tart;
	}
	m = x[0].kulcs;
    for (int i = 0; i < n; i++) {
		if (x[i].kulcs > m) {
			m = x[i].kulcs;
		}
    }
}

void rendezes(int& n, int &m, Elem x[], Elem y[]) {
	int db[m];
	for (int i = 0; i < m; i++) {
		db[i] = 0;
	}
	
	for (int i = 0; i < n; i++) {
		db[x[i].kulcs - 1]++;
		kDb++; //a db-re vonatkozó ++ miatt csak egyszer kell indexelni
	}

	int elso[m];
	elso[0] = 1;
	for (int j = 1; j < m; j++) {
		elso[j] = elso[j - 1] + db[j - 1];
	}
	
	for (int i = 0; i < n; i++) {
		y[elso[x[i].kulcs - 1] - 1] = x[i];
		kDb++;
		mDb++;
		elso[x[i].kulcs - 1]++;
		kDb++; //az elso-re vonatkozo ++ miatt csak egyszer kell indexelni
	}
}

void kiiras(const int& n, Elem y[]) {
	cerr << "Az elemek novekvoen rendezve:";
	for (int i = 0; i < n; i++) {
		cout << i + 1 << ".:" << y[i].kulcs << " " << y[i].tart << endl;
	}
	cout << "Kulcsmezo-indexelesek szama:" << kDb << endl; 
    cout << "Mozgatasok szama:" << mDb << endl; 
}

int main() {
	
	int n, m;
	Elem x[MAXN], y[MAXN];
	
	beolvasas(n, m, x);
	kDb = 0;
	mDb = 0;
	
	rendezes(n, m, x, y);
	kiiras(n, y);
	
	return 0;
}