﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
/*
Feladat: Rendezzünk egy szám kulcsú és szöveg tartalmú rekordokból álló N elemű sorozatot!
Közben számláljuk a kulcsmező-indexelések és a mozgatások számát!
*/
namespace feladat
{
    class Program
    {
        struct Elem
        {
            public int kulcs;
            public string tart;
        }

        static void Beolvasás(out int N, out int M, Elem[] X)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Hány elemet olvasunk be? ");
            N = Convert.ToInt32(Console.ReadLine());
            //A tömb beolvasása
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine("A(z) " + (i + 1) + ". elem kulcsa és szöveges tartalma, szóközzel elválasztva (kulcs tartalom): ");
                string sor = Console.ReadLine();
                string[] adatok = sor.Split(' ');
                X[i].kulcs = Convert.ToInt32(adatok[0]);
                X[i].tart = adatok[1];
            }
            M = X[0].kulcs;
            for (int i = 1; i < N; i++)
            {
                if (X[i].kulcs > M)
                {
                    M = X[i].kulcs;
                }
            }
        }

        static void Csere(ref int egyik, ref int másik)
        {
            int csere = egyik;
            egyik = másik;
            másik = csere;
        }

        static void Rendezés(int N, int M, Elem[] X, Elem[] Y, ref int kDb, ref int mDb)
        {
            int[] db = new int[M];
            for (int i = 0; i < M; i++)
            {//Inicializálás
                db[i] = 0;
            }

            for (int i = 0; i < N; i++)
            {
                db[X[i].kulcs - 1]++;
                kDb++; //a db-re vonatkozó ++ miatt csak egyszer kell indexelni
            }

            int[] elso = new int[M];
            elso[0] = 1;
            for (int j = 1; j < M; j++)
            {
                elso[j] = elso[j - 1] + db[j - 1];
            }

            for (int i = 0; i < N; i++)
            {
                Y[elso[X[i].kulcs - 1] - 1] = X[i];
                kDb++;
                mDb++;
                elso[X[i].kulcs - 1]++;
                kDb++; //az elso-re vonatkozo ++ miatt csak egyszer kell indexelni
            }
        }

        static void Kiírás(int N, Elem[] Y, int kDb, int mDb)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            Console.Error.WriteLine("Rendezett sorozat: ");
            for (int i = 0; i < N; i++)
            {
                Console.WriteLine("{0}. elem: {1} {2}", (i + 1), Y[i].kulcs, Y[i].tart);
            }
            Console.WriteLine("Kulcsmező-indexelések száma: {0}", kDb);
            Console.WriteLine("Mozgatások száma: {0}", mDb);
        }

        static void Main(string[] args)
        {
            //Maximális elemszám
            const int MaxN = 100;
            //A tömb elemszámának deklarálása
            int N;
            int M;
            //A tömb deklarálása
            Elem[] X = new Elem[MaxN];
            Elem[] Y = new Elem[MaxN];
            //Statisztikai adatok deklarálása
            int kDb = 0;//kulcsmező-indexelések száma
            int mDb = 0;//Mozgatások száma
            //Beolvasás
            Beolvasás(out N, out M, X);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Rendezés
            Rendezés(N, M, X, Y, ref kDb, ref mDb);
            //Kiírás
            Kiírás(N, Y, kDb, mDb);
        }
    }
}
