Program Szamlalva_szetoszto_rendezes;
(*
  Feladat: Rendezzünk egy szám kulcsú és szöveg tartalmú rekordokból álló N elemű sorozatot!
  *        Közben számláljuk a kulcsmező-indexelések és a mozgaástosk számát!
*)
  Const
    MaxN=100;
  Type
    TElem=Record kulcs:Integer; tart:String End;
    TKulcsosSzovegek=Array [1..MaxN] of TElem;
    TEgeszek=Array [1..MaxN] of Integer;
  Var
    N,M:Integer;
    X,Y:TKulcsosSzovegek;
    kDb,mDb:LongInt;//kulcsmező-indexelések, mozgatások száma

  Procedure Beolvasas(Var N,M:Integer; Var X:TKulcsosSzovegek);
    Var
      i:integer;
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatornára írandók!
    //Például a kérdések:
    Write(StdErr,'Elemek szama (0..',MaxN,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N);//1<=N<=MaxN
    For i:=1 to N do
    Begin
      Write(StdErr,i:3,'. kulcs (1..',N,') es a szoveg tartalom:'); 
      Readln(X[i].kulcs,X[i].tart);
    End;
    //M meghatározása (kulcs maximum-kiválasztása):
    M:=X[1].kulcs;
    For i:=1 to N do
    Begin
      If X[i].kulcs>M then M:=X[i].kulcs;
    End;
  End;

  Procedure Rendezes(Const N,M:Integer; Const X:TKulcsosSzovegek; Var Y:TKulcsosSzovegek);
    Var
      i,j:Integer;
      db,elso:TEgeszek;
  Begin
    For i:=1 to M do db[i]:=0;
    For i:=1 to N do
    Begin
      Inc(db[X[i].kulcs]);
      Inc(kDb);//a db-re vonatkozó Inc miatt csak egyszer kell indexelni
    End;
    elso[1]:=1;
    For j:=2 to M do
    Begin
      elso[j]:=elso[j-1]+db[j-1];
    End;
    For i:=1 to N do
    Begin
      Y[elso[X[i].kulcs]]:=X[i];
      Inc(kDb);
      Inc(mDb);
      Inc(elso[X[i].kulcs]);
      Inc(kDb);//az elso-re vonatkoz Inc miatt csak egyszer kell indexelni
    End;
  End;

  Procedure Kiiras(Const N:Integer; Const Y:TKulcsosSzovegek);
    Var
      i:Integer;
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Writeln(StdErr,'Az elemek novekvoen rendezve:'); 
    For i:=1 to N do
    Begin
	  Writeln(i,'.:',Y[i].kulcs,Y[i].tart);
    End;
    Writeln('Kulcsmezo-indexelesek szama:',kDb); 
    Writeln('Mozgatasok szama:',mDb); 
  End;
  
Begin
  Beolvasas(N,M,X);
  kDb:=0; mDb:=0;
  Rendezes(N,M,X,Y);
  Kiiras(N,Y);
End.
